<?php

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); 

/**

*

* @version $Id: ps_ini.php 1660 2009-02-22 17:05:02Z tkahl $

* @package VirtueMart

* @subpackage classes

* @copyright Copyright (C) 2004-2007 soeren - All rights reserved.

* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php

* VirtueMart is free software. This version may have been modified pursuant

* to the GNU General Public License, and as distributed it includes or

* is derivative of works licensed under the GNU General Public License or

* other free or open source software licenses.

* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.

*

* http://virtuemart.net

*/





class vm_mShop_ini {

	

	

	/** @var array All ini Elements */

	var $_elements = null;

	

	

	/**

	* Loads a language file and appends the results to the existing strings

	* @param string The name of the file

	* @return boolean True if successful, false is failed

	*/

	function load( $filename ) {

		if (file_exists( $filename ) ) {

			if ($fp = fopen( $filename, 'r' )) {

				$content = fread( $fp, filesize( $filename ) );

				fclose( $fp );

				$this->_elements[] = mShop_ini::parse( $content, false, true );

			}

		}

	}

	/**

	* Parse an .ini string, based on phpDocumentor phpDocumentor_parse_ini_file function

	* @param mixed The ini string or array of lines

	* @param boolean add an associative index for each section [in brackets]

	* @return object

	*/

	function parse( $txt, $process_sections = false, $asArray = false ) {

		if (is_string( $txt )) {

			$lines = explode( "\n", $txt );

		} else if (is_array( $txt )) {

			$lines = $txt;

		} else {

			$lines = array();

		}

		$obj = $asArray ? array() : new stdClass();



		$sec_name = '';

		$unparsed = 0;

		if (!$lines) {

			return $obj;

		}

		foreach ($lines as $line) {

			// ignore comments

			if ($line && $line[0] == ';') {

				continue;

			}

			$line = trim( $line );



			if ($line == '') {

				continue;

			}

			if ($line && $line[0] == '[' && $line[strlen($line) - 1] == ']') {

				$sec_name = substr( $line, 1, strlen($line) - 2 );

				if ($process_sections) {

					if ($asArray) {

						$obj[$sec_name] = array();

					} else {

						$obj->$sec_name = new stdClass();

					}

				}

			} else {

				if ($pos = strpos( $line, '=' )) {

					$property = trim( substr( $line, 0, $pos ) );



					if (substr($property, 0, 1) == '"' && substr($property, -1) == '"') {

						$property = stripcslashes(substr($property,1,count($property) - 2));

					}

					$value = trim( substr( $line, $pos + 1 ) );

					if ($value == 'false') {

						$value = false;

					}

					if ($value == 'true') {

						$value = true;

					}

					if (substr( $value, 0, 1 ) == '"' && substr( $value, -1 ) == '"') {

						$value = stripcslashes( substr( $value, 1, count( $value ) - 2 ) );

					}



					if ($process_sections) {

						if ($sec_name != '') {

							if ($asArray) {

								$obj[$sec_name][$property] = $value;

							} else {

								$obj->$sec_name->$property = $value;

							}

						} else {

							if ($asArray) {

								$obj[$property] = $value;

							} else {

								$obj->$property = $value;

							}

						}

					} else {

						if ($asArray) {

							$obj[$property] = $value;

						} else {

							$obj->$property = $value;

						}

					}

				} else {

					if ($line && trim($line[0]) == ';') {

						continue;

					}

					if ($process_sections) {

						$property = '__invalid' . $unparsed++ . '__';

						if ($process_sections) {

							if ($sec_name != '') {

								if ($asArray) {

									$obj[$sec_name][$property] = trim($line);

								} else {

									$obj->$sec_name->$property = trim($line);

								}

							} else {

								if ($asArray) {

									$obj[$property] = trim($line);

								} else {

									$obj->$property = trim($line);

								}

							}

						} else {

							if ($asArray) {

								$obj[$property] = trim($line);

							} else {

								$obj->$property = trim($line);

							}

						}

					}

				}

			}

		}

		return $obj;

	}

}



// Check if there is an extended class in the Themes and if it is allowed to use them

// If the class is called outside Virtuemart, we have to make sure to load the settings

// Thomas Kahl - Feb. 2009

if (!defined('VM_ALLOW_EXTENDED_CLASSES') && file_exists(dirname(__FILE__).'/../virtuemart.cfg.php')) {

	include_once(dirname(__FILE__).'/../virtuemart.cfg.php');

}

// If settings are loaded, extended Classes are allowed and the class exisits...

if (defined('VM_ALLOW_EXTENDED_CLASSES') && defined('VM_THEMEPATH') && VM_ALLOW_EXTENDED_CLASSES && file_exists(VM_THEMEPATH.'user_class/'.basename(__FILE__))) {

	// Load the theme-user_class as extended

	include_once(VM_THEMEPATH.'user_class/'.basename(__FILE__));

} else {

	// Otherwise we have to use the original classname to extend the core-class

	class mShop_ini extends vm_mShop_ini {}

}

?>

